#include <bits/stdc++.h>
#include <algorithm>
#define int long long

using namespace std;
void solve(){
    int n, m;
    cin>>n>>m;
    vector<int> a(m);
    for(int i=0; i<m; i++){
        cin>>a[i];
    }
    vector<int> r;
    for(int i=0; i<m; i++){
        if(a[i]!=INT_MAX){
            for(int j=0; j<m; j++){
                if(a[i]%a[j]==0 and i!=j){
                    a[j]=INT_MAX;
                }
            }
        }
    }
    int k=0;
    for(int i : a)if(i!=INT_MAX)k++;
    cout<<k<<'\n';
    for(int i : a){
        if(i!=INT_MAX){
            if(i%n==0)cout<<i/n<<" ";
            else cout<<i<<' ';
        }
    }
}
main(){
    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    int t=1;
    while(t--)solve();
}
